Ruby 2.7.0p0(2019-12-25revision647ee6f091eafcce70ffb75ddf7e121e192ab217)

Data Structures | Macros | Typedefs | Enumerations | Functions | Variables
dir.c File Reference
`#include "ruby/encoding.h"`
`#include "ruby/thread.h"`
`#include "internal.h"`
`#include "id.h"`
`#include "encindex.h"`
`#include <sys/types.h>`
`#include <sys/stat.h>`
`#include <errno.h>`
`#include <ctype.h>`
`#include "ruby/util.h"`

Go to the source code of this file.

## Data Structures
struct | dir_data
struct | chdir_data
struct | mkdir_arg
struct | warning_args
struct | ruby_glob_funcs_t
struct | opendir_at_arg
struct | glob_pattern
struct | glob_args
struct | glob_error_args
struct | push_glob_args
struct | dirent_brace_args
struct | push_glob0_args
struct | brace_args

## Macros
#define | O_CLOEXEC 0
#define | USE_OPENDIR_AT 0
#define | AT_FDCWD -1
#define | dirent direct
#define | NAMLEN(dirent) (dirent)->d_namlen
#define | HAVE_DIRENT_NAMLEN 1
#define | vm_initialized rb_cThread
#define | IS_WIN32 0
#define | USE_NAME_ON_FS_REAL_BASENAME
#define | USE_NAME_ON_FS_BY_FNMATCH
#define | USE_NAME_ON_FS 0
#define | NORMALIZE_UTF8PATH 0
#define | IF_NORMALIZE_UTF8PATH(something) /* nothing */
#define | IFTODT(m) (((m) & S_IFMT) / ((~S_IFMT & (S_IFMT-1)) + 1))
#define | FNM_NOESCAPE 0x01
#define | FNM_PATHNAME 0x02
#define | FNM_DOTMATCH 0x04
#define | FNM_CASEFOLD 0x08
#define | FNM_EXTGLOB 0x10
#define | FNM_SYSCASE 0
#define | FNM_SHORTNAME 0
#define | FNM_NOMATCH 1
#define | FNM_ERROR 2
#define | Next(p, e, enc) ((p)+ rb_enc_mbclen((p), (e), (enc)))
#define | Inc(p, e, enc) ((p) = Next((p), (e), (enc)))
#define | UNESCAPE(p) (escape && *(p) == '\\' ? (p) + 1 : (p))
#define | ISEND(p) (!*(p) || (pathname && *(p) == '/'))
#define | RETURN(val) return *pcur = p, *scur = s, (val);
#define | GetDIR(obj, dirp) ((dirp) = dir_check(obj))
#define | dir_fileno rb_f_notimplement
#define | READDIR(dir, enc) readdir((dir))
#define | dir_tell rb_f_notimplement
#define | dir_seek rb_f_notimplement
#define | dir_set_pos rb_f_notimplement
#define | RUBY_UNTYPED_DATA_WARNING 0
#define | dir_s_chroot rb_f_notimplement
#define | sys_enc_warning_in(func, mesg, enc) sys_enc_warning(mesg, enc)
#define | GLOB_VERBOSE (1U << (sizeof(int) * CHAR_BIT - 1))
#define | sys_warning(val, enc) ((flags & GLOB_VERBOSE) ? sys_enc_warning_in(RUBY_FUNCTION_NAME_STRING, (val), (enc)) :(void)0)
#define | GLOB_ALLOC(type) ((type *)malloc(sizeof(type)))
#define | GLOB_ALLOC_N(type, n) ((type *)glob_alloc_n(sizeof(type), n))
#define | GLOB_REALLOC(ptr, size) realloc((ptr), (size))
#define | GLOB_FREE(ptr) free(ptr)
#define | GLOB_JUMP_TAG(status) (((status) == -1) ? rb_memerror() : rb_jump_tag(status))
#define | STAT(p, s) stat((p), (s))
#define | do_lstat do_stat
#define | S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)
#define | S_ISLNK(m) (0)
#define | glob_call_func(func, path, arg, enc) (*(func))((path), (arg), (void *)(enc))

## Typedefs
typedef int | ruby_glob_errfunc(const char *, VALUE, const void *, int)

## Enumerations
enum | rb_pathtype_t { path_exist, path_directory = IFTODT(S_IFDIR), path_regular = IFTODT(S_IFREG), path_symlink = IFTODT(S_IFLNK), path_noent = -1, path_unknown = -2 }
enum | glob_pattern_type { PLAIN, ALPHA, BRACE, MAGICAL, RECURSIVE, MATCH_ALL, MATCH_DIR }

## Functions
char * | getenv ()
char * | strchr (char *, char)
| NORETURN (static void dir_closed(void))
VALUE | rb_dir_getwd_ospath (void)
VALUE | rb_dir_getwd (void)
| ALWAYS_INLINE (static int to_be_ignored(int e))
int | ruby_glob (const char *path, int flags, ruby_glob_func *func, VALUE arg)
void | rb_glob (const char *path, void(*func)(const char *, VALUE, void *), VALUE arg)
int | ruby_brace_glob_with_enc (const char *str, int flags, ruby_glob_func *func, VALUE arg, rb_encoding *enc)
int | ruby_brace_glob (const char *str, int flags, ruby_glob_func *func, VALUE arg)
void | Init_Dir (void)

## Variables
VALUE | rb_cDir

## Macro Definition Documentation

## ◆ AT_FDCWD

#define AT_FDCWD -1

Definition at line 43 of file dir.c.

## ◆ dir_fileno

#define dir_fileno rb_f_notimplement

Definition at line 702 of file dir.c.

## ◆ dir_s_chroot

#define dir_s_chroot rb_f_notimplement

Definition at line 1218 of file dir.c.

## ◆ dir_seek

#define dir_seek rb_f_notimplement

Definition at line 916 of file dir.c.

## ◆ dir_set_pos

#define dir_set_pos rb_f_notimplement

Definition at line 940 of file dir.c.

## ◆ dir_tell

#define dir_tell rb_f_notimplement

Definition at line 887 of file dir.c.

## ◆ dirent

#define dirent direct

Definition at line 54 of file dir.c.

## ◆ do_lstat

#define do_lstat do_stat

Definition at line 1428 of file dir.c.

## ◆ FNM_CASEFOLD

#define FNM_CASEFOLD 0x08

Definition at line 200 of file dir.c.

## ◆ FNM_DOTMATCH

#define FNM_DOTMATCH 0x04

Definition at line 199 of file dir.c.

## ◆ FNM_ERROR

#define FNM_ERROR 2

Definition at line 214 of file dir.c.

## ◆ FNM_EXTGLOB

#define FNM_EXTGLOB 0x10

Definition at line 201 of file dir.c.

## ◆ FNM_NOESCAPE

#define FNM_NOESCAPE 0x01

Definition at line 197 of file dir.c.

## ◆ FNM_NOMATCH

#define FNM_NOMATCH 1

Definition at line 213 of file dir.c.

## ◆ FNM_PATHNAME

#define FNM_PATHNAME 0x02

Definition at line 198 of file dir.c.

## ◆ FNM_SHORTNAME

#define FNM_SHORTNAME 0

Definition at line 210 of file dir.c.

## ◆ FNM_SYSCASE

#define FNM_SYSCASE 0

Definition at line 205 of file dir.c.

## ◆ GetDIR

#define GetDIR | ( |  | obj,
|  |  | dirp
| ) |  | ((dirp) = dir_check(obj))

Definition at line 635 of file dir.c.

## ◆ GLOB_ALLOC

#define GLOB_ALLOC | ( |  | type | ) | ((type *)malloc(sizeof(type)))

Definition at line 1355 of file dir.c.

## ◆ GLOB_ALLOC_N

#define GLOB_ALLOC_N | ( |  | type,
|  |  | n
| ) |  | ((type *)glob_alloc_n(sizeof(type), n))

Definition at line 1356 of file dir.c.

## ◆ glob_call_func

#define glob_call_func | ( |  | func,
|  |  | path,
|  |  | arg,
|  |  | enc
| ) |  | (*(func))((path), (arg), (void *)(enc))

Definition at line 1943 of file dir.c.

## ◆ GLOB_FREE

#define GLOB_FREE | ( |  | ptr | ) | free(ptr)

Definition at line 1358 of file dir.c.

## ◆ GLOB_JUMP_TAG

#define GLOB_JUMP_TAG | ( |  | status | ) | (((status) == -1) ? rb_memerror() : rb_jump_tag(status))

Definition at line 1359 of file dir.c.

## ◆ GLOB_REALLOC

#define GLOB_REALLOC | ( |  | ptr,
|  |  | size
| ) |  | realloc((ptr), (size))

Definition at line 1357 of file dir.c.

## ◆ GLOB_VERBOSE

#define GLOB_VERBOSE (1U << (sizeof(int) * CHAR_BIT - 1))

Definition at line 1339 of file dir.c.

## ◆ HAVE_DIRENT_NAMLEN

#define HAVE_DIRENT_NAMLEN 1

Definition at line 56 of file dir.c.

## ◆ IF_NORMALIZE_UTF8PATH

#define IF_NORMALIZE_UTF8PATH | ( |  | something | ) | /* nothing */

Definition at line 174 of file dir.c.

## ◆ IFTODT

#define IFTODT | ( |  | m | ) | (((m) & S_IFMT) / ((~S_IFMT & (S_IFMT-1)) + 1))

Definition at line 178 of file dir.c.

## ◆ Inc

#define Inc | ( |  | p,
|  |  | e,
|  |  | enc
| ) |  | ((p) = Next((p), (e), (enc)))

Definition at line 217 of file dir.c.

## ◆ IS_WIN32

#define IS_WIN32 0

Definition at line 100 of file dir.c.

## ◆ ISEND

#define ISEND | ( |  | p | ) | (!*(p) || (pathname && *(p) == '/'))

Definition at line 294 of file dir.c.

## ◆ NAMLEN

#define NAMLEN | ( |  | dirent | ) | (dirent)->d_namlen

Definition at line 55 of file dir.c.

## ◆ Next

#define Next | ( |  | p,
|  |  | e,
|  |  | enc
| ) |  | ((p)+ rb_enc_mbclen((p), (e), (enc)))

Definition at line 216 of file dir.c.

## ◆ NORMALIZE_UTF8PATH

#define NORMALIZE_UTF8PATH 0

Definition at line 125 of file dir.c.

## ◆ O_CLOEXEC

#define O_CLOEXEC 0

Definition at line 28 of file dir.c.

## ◆ READDIR

#define READDIR | ( |  | dir,
|  |  | enc
| ) |  | readdir((dir))

Definition at line 740 of file dir.c.

## ◆ RETURN

#define RETURN | ( |  | val | ) | return *pcur = p, *scur = s, (val);

Definition at line 295 of file dir.c.

## ◆ RUBY_UNTYPED_DATA_WARNING

#define RUBY_UNTYPED_DATA_WARNING 0

## ◆ S_ISDIR

#define S_ISDIR | ( |  | m | ) | (((m) & S_IFMT) == S_IFDIR)

Definition at line 1923 of file dir.c.

## ◆ S_ISLNK

#define S_ISLNK | ( |  | m | ) | (0)

Definition at line 1928 of file dir.c.

## ◆ STAT

#define STAT | ( |  | p,
|  |  | s
| ) |  | stat((p), (s))

Definition at line 1377 of file dir.c.

## ◆ sys_enc_warning_in

#define sys_enc_warning_in | ( |  | func,
|  |  | mesg,
|  |  | enc
| ) |  | sys_enc_warning(mesg, enc)

Definition at line 1312 of file dir.c.

## ◆ sys_warning

#define sys_warning | ( |  | val,
|  |  | enc
| ) |  | ((flags & GLOB_VERBOSE) ? sys_enc_warning_in(RUBY_FUNCTION_NAME_STRING, (val), (enc)) :(void)0)

Definition at line 1340 of file dir.c.

## ◆ UNESCAPE

#define UNESCAPE | ( |  | p | ) | (escape && *(p) == '\\' ? (p) + 1 : (p))

Definition at line 293 of file dir.c.

## ◆ USE_NAME_ON_FS

#define USE_NAME_ON_FS 0

Definition at line 119 of file dir.c.

## ◆ USE_NAME_ON_FS_BY_FNMATCH

#define USE_NAME_ON_FS_BY_FNMATCH

Value:
2 /* select the matching
* basename by fnmatch */

Definition at line 108 of file dir.c.

## ◆ USE_NAME_ON_FS_REAL_BASENAME

#define USE_NAME_ON_FS_REAL_BASENAME

Value:
1 /* platform dependent APIs to
* get real basenames */

Definition at line 107 of file dir.c.

## ◆ USE_OPENDIR_AT

#define USE_OPENDIR_AT 0

Definition at line 36 of file dir.c.

## ◆ vm_initialized

#define vm_initialized rb_cThread

Definition at line 85 of file dir.c.

## Typedef Documentation

## ◆ ruby_glob_errfunc

typedef int ruby_glob_errfunc(const char *, VALUE, const void *, int)

Definition at line 1380 of file dir.c.

## Enumeration Type Documentation

## ◆ glob_pattern_type

enum glob_pattern_type

Enumerator
PLAIN |
ALPHA |
BRACE |
MAGICAL |
RECURSIVE |
MATCH_ALL |
MATCH_DIR |

Definition at line 1542 of file dir.c.

## ◆ rb_pathtype_t

enum rb_pathtype_t

Enumerator
path_exist |
path_directory |
path_regular |
path_symlink |
path_noent |
path_unknown |

Definition at line 181 of file dir.c.

## Function Documentation

## ◆ ALWAYS_INLINE()

ALWAYS_INLINE | ( | static int | to_be_ignoredint e | ) |

## ◆ getenv()

char* getenv | ( |  | ) |

## ◆ Init_Dir()

void Init_Dir | ( | void |  | ) |

Definition at line 3393 of file dir.c.

References rb_cDir, rb_cObject, rb_define_alloc_func(), rb_define_class(), rb_include_module(), and rb_mEnumerable.

## ◆ NORETURN()

NORETURN | ( | static void | dir_closedvoid | ) |

## ◆ rb_dir_getwd()

VALUE rb_dir_getwd | ( | void |  | ) |

Definition at line 1141 of file dir.c.

References ENCINDEX_ASCII, ENCINDEX_US_ASCII, NULL, rb_dir_getwd_ospath(), rb_enc_associate_index(), rb_enc_to_index(), rb_encoding, rb_filesystem_encoding(), and rb_str_conv_enc().

## ◆ rb_dir_getwd_ospath()

VALUE rb_dir_getwd_ospath | ( | void |  | ) |

Definition at line 1117 of file dir.c.

Referenced by rb_dir_getwd().

## ◆ ruby_brace_glob_with_enc()

int ruby_brace_glob_with_enc | ( | const char * | str,
|  | int | flags,
|  | ruby_glob_func * | func,
|  | VALUE | arg,
|  | rb_encoding * | enc
| ) |  |

Definition at line 2646 of file dir.c.

References arg, ruby_glob_funcs_t::error, brace_args::flags, brace_args::funcs, GLOB_VERBOSE, ruby_glob_funcs_t::match, NULL, and brace_args::value.

Referenced by ruby_brace_glob().

## ◆ strchr()

char* strchr | ( | char * | ,
|  | char |
| ) |  |

Referenced by nl_langinfo_codeset(), rb_feature_provided(), rb_io_modestr_fmode(), rb_path_check(), ruby_scan_hex(), and strtod().

## Variable Documentation

## ◆ rb_cDir

VALUE rb_cDir

Definition at line 439 of file dir.c.

Referenced by Init_Dir().